/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage;

public abstract class JavaStageCtrl { 

  public static void world_init_pre()
  {
  }
  public void init() 
  {
  }
  public static void world_init_after()
  {
  }

  public static void world_wrapup()
  {
  }

  public void p_callback()
  {
  }

  public void update_link()
  {
  }

  public static void log()
  {
  }

  /* member and constructor */
  public int robot_p;
  public int node_index;

  public int GetRobotP() {
    return robot_p;
  }
  public  int GetNodeIndex() {
    return node_index;
  }

  public JavaStageCtrl(int robot_p, int node_index) {
    this.robot_p = robot_p;
    this.node_index = node_index;
  }

  public JavaStageCtrl() {
//    System.out.println("Model pointer should be set up, use JavaStageCtrl(robot_p) consturctor");
//    System.exit(1);
  }

  static { 
    System.loadLibrary("wander_wifi");  
    //System.out.println("JavaStageCtrl Class load Library..");
  }
}
