/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage;

public class LaserInterface {
  LaserInterface() {
    System.out.println("Model pointer should be set up at default constructor");
    System.exit(1);
  }
  LaserInterface(JavaStageCtrl ctrl) {
    this.robot_p = ctrl.GetRobotP();
  }
  int robot_p;
  
  public LaserConfig GetConfig() { return _GetConfig(this.robot_p); }
  public LaserSampleStage [] GetSamples() {  return _GetSamples(this.robot_p); }

  public static native LaserConfig _GetConfig(int robot_p);
  public static native LaserSampleStage [] _GetSamples(int robot_p);

}


