/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage;

public class PositionInterface 
{
  PositionInterface( ) 
  {
    System.out.println("Model pointer should be set up");
    System.exit(1);
  }
  PositionInterface(JavaStageCtrl ctrl) 
  {
    this.robot_p = ctrl.GetRobotP();
  }
  int robot_p;

  // model position 
  public void SetSpeed(double x, double y, double a){ _SetSpeed(x,  y , a, this.robot_p); }
  public void GoTo(double x, double y, double a) { _GoTo(x, y, a, this.robot_p);  }
  public void SetTurnSpeed(double a) { _SetTurnSpeed(a, this.robot_p); }
  public void Stop() { _Stop(this.robot_p); }
  public static void _Stop(int robot_p) { _SetSpeed(0, 0, 0, robot_p); }
  public static native void _SetSpeed(double x, double y, double a, int robot_p);
  public static native void _GoTo(double x, double y, double a, int robot_p);
  public static native void _SetTurnSpeed(double a, int robot_p);
}
