/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage;

public class SimulationInterface
{
  SimulationInterface () 
  {
    System.out.println("Model pointer should be set up");
    System.exit(1);
  }
  
  SimulationInterface(JavaStageCtrl ctrl) 
  {
    this.robot_p = ctrl.GetRobotP();
  }
  int robot_p;

  private static int num_robot_p; // number of robot model pointer
  private static int[] robot_p_vec = new int[100]; // robot pointer array
  
  public static int GetNumRobotP() {
    return num_robot_p;
  }
  
  public static int [] GetRobotPVector() {
    return robot_p_vec;
  }
  
  public static  void add_ap_callback(double time/*ms*/, ApCallback cb){ 
    if(time != java.lang.Double.POSITIVE_INFINITY) 
      _add_ap_callback(time, cb); 
  }

  // natives
  public static native Size _GetFloorplanSize(int robot_p);
  public static native void _add_ap_callback(double time, ApCallback cb);

  // world
  public static native long TimeNow(); //return usec
}
