/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage;

import cf.sim.SimEngine;

class WifiRcv implements WifiMsgRcvFn {
  JavaStageCtrlCyberFramework ctrl;
  WifiRcv(JavaStageCtrlCyberFramework c) {
    ctrl = c;
  }
  WifiRcv() 
  {
  }

  // wifi message event callback
  public void func(WifiMessageBase msg) 
  {
    if(msg instanceof WifiMessageCF)
    {
      WifiMessageCF rcv_msg = (WifiMessageCF)msg; 
      SimEngine.log.println(3, "Robot[" + rcv_msg.recipient_node_index + "] got neighbor[" + rcv_msg.sender_node_index + "]'s message, " + 
    		  "it says :" + rcv_msg.message+ ", time: "+SimulationInterface.TimeNow() + " us, bundle ID: " + rcv_msg.tm.payload().logRepLong()+ ", link id: " + rcv_msg.tm.link().index()+"\n");

      int robot_p = SimulationInterface.GetRobotPVector()[ rcv_msg.recipient_node_index ];
      //ModelInterface._Say("   " + rcv_msg.recipient_node_index + ":\""+rcv_msg.message+"\"<=" + rcv_msg.sender_node_index, robot_p);

      if(rcv_msg.tm_cancled) 
      {
        // under SNR thresh hold case, set transmission is error
        rcv_msg.tm.SetError();
        //      System.out.println("TM canceld");
      }
      //      System.out.println("handle TM called");
      rcv_msg.tm.link().handleTransmitted_stage(rcv_msg.tm);
    }
    else 
    {
      return;
    }
  }
}
