/*

  Copyright 2010, 2011 SRI International and Seoul National University

  Licensed under the Apache License, Version 2.0 (the "License"); you may
  not use this file except in compliance with the License. You may obtain
  a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  The development was supported by National Science Foundation Grant 0932397:
  A Logical Framework for Self-Optimizing Networked Cyber-Physical Systems

*/

package cf.sim.stage.devices;

import cf.api.CyberApplication;
import cf.api.devices.Area;
import cf.api.devices.Camera;
import cf.api.devices.CameraApplication;
import cf.api.devices.Image;
import cf.common.Model;
import cf.sim.SimWorld;
import cf.sim.stage.JavaStageCtrl;

public class SimCameraStage extends Model implements Camera
{

  public JavaStageCtrl ctrl;
  static private int taken_count  = 0;

  public SimCameraStage(JavaStageCtrl ctrl, SimWorld world)
  {
    super(world);
    this.ctrl = ctrl;
  }

  public SimCameraStage(JavaStageCtrl ctrl, SimWorld world, String name)
  {
    super(world,name);
    this.ctrl = ctrl;
  }

  public SimCameraStage(JavaStageCtrl ctrl, SimWorld world, Model parent, String name)
  {
    super(world,parent,name);
    this.ctrl = ctrl;
  }

  public void addApplication(CameraApplication app)
  {
    addApplication((CyberApplication)app);
  }

  public Image takeImage(Area area)
  {
    int robot_p = ctrl.GetRobotP();
    taken_count++;
    //return new Image(time(), area, CameraInterface._getWidth(robot_p), CameraInterface._getHeight(robot_p), CameraInterface._FrameDepth(robot_p), CameraInterface._FrameColor(robot_p) );
    return new Image(time(), area);
  }

  public String logRepLong()
  {
    return super.logRepLong() + " Camera:taken image count: (" +taken_count+")";

  }
}
