#!/usr/bin/env python
import sys
node_count =  int()
worldfilename = str()
success_rate =  int()
end_time = int()
if len(sys.argv) > 4:
    node_count = sys.argv[1]
    worldfilename = sys.argv[2]
    success_rate = sys.argv[3]
    end_time = sys.argv[4]
else:
    print "USAGE: genworld.py [node count] [worldfilename] [link success rate]  [quit time] "
    sys.exit()

f  = open(worldfilename, "w")

colorlist = [ "red", "orange", "yellow", "blue", "green", "purple" ]

#f.write("""
header_templete = """
include "map.inc"
include "pioneer.inc"
include "sick.inc"

interval_sim 1  # simulation timestep in milliseconds
#interval_real 1  # real-time interval between simulation updates in milliseconds
#show_clock 1
#show_clock_interval 10
speedup -1


quit_time ##END_TIME

paused 0

resolution 0.02

# configure the GUI window
window
(
    size [ 800 800 ] # in pixels
    scale 3.5
# pixels per meter
    center [ 0  0 ]
    rotate [ 0  0 ]

    show_data 1              # 1=on 0=off
    interval 100 # gui update interval ms
)

# load an environment bitmap
floorplan
(
    name "cps_stage"
    size [200.0 200.0 1.0 ]
    pose [0 0 0 0]
    #bitmap "bitmaps/rink.png"
    #bitmap "bitmaps/cave.png"
    #bitmap "bitmaps/blank.png"
    bitmap "bitmaps/city.png"
)

"""

robot_templete = """
pioneer2dx
(
  # can refer to the robot by this name
    name "##NAME"
    color "##COLOR"
    pose [0 0 0 0]
    sicklaser()

    ctrl "wander_wifi"

# report error-free position in world coordinates
    localization "gps"
    localization_origin [ 0 0 0 0 ]

    joules 10000
    joules_capacity 10000

    wifi(
        ip "##IPADDR"
        mac "08:00:20:ae:fd:7e"
        netmask "255.255.255.0"
        essid "test network"
        model "friis"
        #model "ITU indoor"
        #model "raytrace"
        #wall_factor 5
        power 15
        sensitivity -65
        #range_db -45
        link_success_rate ##SUCCESS_RATE 
        random_seed 10
    )
    camera(
        pose [ 0 0 0 0 ]
        range [ 0.2 8.0 ]
        resolution [ 100 100 ]
        fov [ 70 40 ]
        pantilt [ 0 0 ]
        alwayson 1
    )
)

"""

header_templete = header_templete.replace("##END_TIME", end_time);
f.write(header_templete);

print "node count : "+str(node_count)
import random
for t in range(0, int(node_count)):
  print t
  text = robot_templete.replace("##NAME", "r"+ str(t))
  text = text.replace("##COLOR", str(colorlist[ random.randint(0,5) ]) )
  text = text.replace("##IPADDR", "192.168.0."+str(t+2));
  text = text.replace("##SUCCESS_RATE", success_rate);
  print text
  f.write(str(text));
f.close()
